package schedframe.resources.computing;

import schedframe.resources.computing.description.ComputingResourceDescription;
import schedframe.resources.computing.profiles.energy.EnergyExtension;
import schedframe.resources.computing.profiles.energy.power.PowerProfileFactory;
import schedframe.resources.computing.profiles.energy.power.ui.PowerInterface;

public class DataCenter extends ComputingResource{

	public DataCenter(ComputingResourceDescription resDesc) {
		super(resDesc);
		//extensionList.add(new EnergyExtension(this, resDesc.getPowerInterface(), resDesc.getEnergyEstimationPlugin()));
		PowerInterface pi = PowerProfileFactory.createPowerInterface(this, resDesc.getPowerProfile());
		accept(new EnergyExtension(pi, resDesc.getPowerProfile()));
	}
		
	public void accept(EnergyExtension e){
		extensionList.add(e);
		e.setResource(this);
	}
}
