package schedframe.scheduling.plugin.local;

import java.util.Map;

import schedframe.resources.units.ResourceUnit;
import schedframe.resources.units.ResourceUnitName;

public interface ResourceAllocationInterface {
	
	/**
	 * Allocates resource units( marks as used) on the basis of given resource
	 * units.
	 * 
	 * @param freeRes
	 *            resource units to be consumed
	 */
	public boolean allocateResources(Map<ResourceUnitName, ResourceUnit> freeRes);

	/**
	 * Frees given resource units.
	 * 
	 * @param lastUsedResources
	 *            resource units to be free
	 */
	public void freeResources(Map<ResourceUnitName, ResourceUnit> lastUsedResources);
	
	//public void allocateProcessors(Map<ResourceParameterName, ResourceUnit> freeRes);
	

	//public void clearPendingProcessors(List<Resource> choosenResources);
	

}
