package simulator.stats.implementation;

import java.util.Map;
import java.util.TreeMap;

import schedframe.resources.ResourceType;
import simulator.stats.implementation.out.StatsSerializer;

public class ResourceEnergyStats {
	protected Map<Long, Double> energy;
	protected String resourceName;
	protected String usageType;
	protected ResourceType resourceType;
	protected double meanUsage;
	protected double sumUsage;
	
	public void setSumUsage(double sumUsage) {
		this.sumUsage = sumUsage;
	}

	public double getSumUsage() {
		return sumUsage;
	}
	public void setMeanUsage(double meanUsage) {
		this.meanUsage = meanUsage;
	}
	
	public double getMeanUsage() {
		return meanUsage;
	}
	
	private String[] headers = { "resourceName", "timestamp", "usage" };
	
	public ResourceEnergyStats (String resourceName, ResourceType resourceType, String usageType) {
		this.resourceName = resourceName;
		this.resourceType = resourceType;
		this.usageType = usageType;
		this.energy = new TreeMap<Long, Double>();
		this.meanUsage = 0;
	}

	public String getResourceName() {
		return this.resourceName;
	}
	
	public ResourceType getResourceType() {
		return resourceType;
	}

	public String getUsageType() {
		return this.usageType;
	}	

	public Map<Long, Double> getEnergy() {
		return this.energy;
	}

	public Object serialize(StatsSerializer serializer) {
		return serializer.visit(this);
	}

	public String[] getHeaders() {
		return headers;
	}

}
