package simulator.workload.reader.archive.swf;

import java.io.IOException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import simulator.workload.reader.archive.AbstractWAParser;


/**
 * 
 * @author Marcin Krystek
 *
 */

public class SWFParser extends AbstractWAParser {

	private Log log = LogFactory.getLog(SWFParser.class);
 
	public SWFParser(String fileName) throws IOException, NullPointerException{
		super(fileName);
		this.fieldsNo = 18;
		this.COMMENT = ";";
	}

	
	public String[] readTask(String id) throws IOException{
		String fields[] = null;
		boolean found = false;
		
		
		Long jobPosition = this.jobIndex.get(id);
		
		// if index for job id is calculated, then use it!
		if(jobPosition != null){
			super.seek(jobPosition);
			fields = readTask();
			if(!id.equals(fields[0])) {
				log.error("Wrong index for task: " + id + ". Found task: " + fields[0]);
				return null;
			}
		} else {
			// do classic search, read file from current position to the end, move to the beginning
			// and continue to current position
			
			long filePointer = getFilePointer();
			// reads from current position to the end of file
			while(!found && (fields = readTask()) != null){
				if(fields[SWFFields.DATA_JOB_NUMBER].equals(id))
					found = true;
			}
			
			if(!found){
				// back to the beginning
				System.out.println("search from begin for " + id);
				super.seek(0);
				// reads from the beginning of file to current position
				while(!found && filePointer != getFilePointer() && (fields = readTask()) != null){
					if(fields[SWFFields.DATA_JOB_NUMBER].equals(id))
						found = true;
				}
			}
		
			if(found == false) return null;
		}
		
		return fields;
	}
	
	protected void buildIdx(String line, long position){
		if(line == null || line.length() == 0)
			return;
		
		String fields[] = line.split(FIELD_SEPARATOR+"+");

		if(fields == null || fields.length != fieldsNo) {
			int i = (fields == null ?  -1 : fields.length);
			log.error("Can not build job index for line: " + line +
					"\nSome data fields are missing. Expected fields length is " + fieldsNo + ", in file is " + i );
			fields = null;
			return;
		} 
		
		String jobId = fields[SWFFields.DATA_JOB_NUMBER];
		this.jobIndex.put(jobId, position);
	}
	
	public int getType(){
		return 0;
	}
	
}
