package org.qcg.broker.schemas.exception;

import org.qcg.broker.schemas.hostparams.types.ComputingParameterName;
import org.qcg.broker.schemas.hostparams.types.NetworkParameterName;
import org.qcg.broker.schemas.hostparams.types.QueueParameterName;
import org.qcg.broker.schemas.resreqs.types.ComputingResourceParameterTypeNameType;
import org.qcg.broker.schemas.resreqs.types.NetworkParameterTypeNameType;

public class NoSuchParamException extends Exception{

	private static final long serialVersionUID = 5595831921723344358L;

	protected String paramName;
	
	public NoSuchParamException(){
		super();
	}
	
	public NoSuchParamException(String message){
		super(message);
	}
	
	public NoSuchParamException(ComputingParameterName paramName, String message){
		super(message);
		this.paramName = paramName.toString();
	}
	
	public NoSuchParamException(NetworkParameterName paramName, String message){
		super(message);
		this.paramName = paramName.toString();
	}
	
	public NoSuchParamException(QueueParameterName paramName, String message){
		super(message);
		this.paramName = paramName.toString();
	}
	
	public NoSuchParamException(ComputingResourceParameterTypeNameType paramName, String message){
		super(message);
		this.paramName = paramName.toString();
	}
	
	public NoSuchParamException(NetworkParameterTypeNameType paramName, String message){
		super(message);
		this.paramName = paramName.toString();
	}
	
	public NoSuchParamException(org.qcg.broker.schemas.jobdesc.types.ComputingParameterName paramName, String message){
		super(message);
		this.paramName = paramName.toString();
	}
	
	public NoSuchParamException(org.qcg.broker.schemas.jobdesc.types.NetworkParameterName paramName, String message){
		super(message);
		this.paramName = paramName.toString();
	}
	
	
	public NoSuchParamException(String paramName, String message){
		super(message);
		this.paramName = paramName;
	}
	
	public String getParamName(){
		return this.paramName;
	}
	
	
	public String toString(){
		return getMessage() + "; (" + this.paramName + ")";
	}
}
