package org.qcg.broker.schemas.jobdesc.wrapper;

import org.qcg.broker.schemas.exception.NoSuchParamException;
import org.qcg.broker.schemas.jobdesc.ComputingResourceNetParameterType;
import org.qcg.broker.schemas.jobdesc.ComputingResourceParameterType;
import org.qcg.broker.schemas.jobdesc.ComputingResourceType;
import org.qcg.broker.schemas.jobdesc.OtherParameterType;
import org.qcg.broker.schemas.jobdesc.ResourceTemplatesType;
import org.qcg.broker.schemas.jobdesc.types.ComputingParameterName;
import org.qcg.broker.schemas.jobdesc.types.NetworkParameterName;
import org.qcg.broker.schemas.utils.ComputingResourceParamExplorer;

public interface ComputingResourceJobDescParamExplorer extends ComputingResourceParamExplorer
															<ComputingResourceType, ComputingResourceNetParameterType, 
															ComputingResourceParameterType, OtherParameterType, 
															ComputingParameterName, 
															NetworkParameterName>{
	
	public double getMinMemory() throws NoSuchParamException;
	public double getMaxMemory() throws NoSuchParamException;
	public double[][] getRangeMemory() throws NoSuchParamException;
	
	public double getMinFreememory() throws NoSuchParamException;
	public double getMaxFreememory() throws NoSuchParamException;
	public double[][] getRangeFreememory() throws NoSuchParamException;
	
	public double getMinCpucount() throws NoSuchParamException;
	public double getMaxCpucount() throws NoSuchParamException;
	public double[][] getRangeCpucount() throws NoSuchParamException;
	
	public double getMinFreecpus() throws NoSuchParamException;
	public double getMaxFreecpus() throws NoSuchParamException;
	public double[][] getRangeFreecpus() throws NoSuchParamException;
	
	public double getMinCpuload() throws NoSuchParamException;
	public double getMaxCpuload() throws NoSuchParamException;
	public double[][] getRangeCpuload() throws NoSuchParamException;
	
	public double getMinCpuspeed() throws NoSuchParamException;
	public double getMaxCpuspeed() throws NoSuchParamException;
	public double[][] getRangeCpuspeed() throws NoSuchParamException;
	
	public double getMinDiskspace() throws NoSuchParamException;
	public double getMaxDiskspace() throws NoSuchParamException;
	public double[][] getRangeDiskspace() throws NoSuchParamException;
	
	public double getMinFreediskspace() throws NoSuchParamException;
	public double getMaxFreediskspace() throws NoSuchParamException;
	public double[][] getRangeFreediskspace() throws NoSuchParamException;
	
	public double getMinBandwidth() throws NoSuchParamException;
	public double getMaxBandwidth() throws NoSuchParamException;
	public double[][] getRangeBandwidth() throws NoSuchParamException;
	
	public double getMinLatency() throws NoSuchParamException;
	public double getMaxLatency() throws NoSuchParamException;
	public double[][] getRangeLatency() throws NoSuchParamException;
	
	public double getMinCapacity() throws NoSuchParamException;
	public double getMaxCapacity() throws NoSuchParamException;
	public double[][] getRangeCapacity() throws NoSuchParamException;

	public void setResourceTemplates(ResourceTemplatesType resourceTemplates);
}
