package org.qcg.broker.schemas.jobdesc.wrapper;

import org.qcg.broker.schemas.exception.ElementNotSpecified;
import org.qcg.broker.schemas.exception.ValueNotSpecified;
import org.qcg.broker.schemas.jobdesc.Parameter;
import org.qcg.broker.schemas.jobdesc.PreferencesType;
import org.qcg.broker.schemas.jobdesc.Task;

/**
 * 
 * @author Marcin Krystek
 *
 */
public interface TaskPreferences {

	public void wrap(Task task);
	
	public Parameter getParameter(String name) throws ElementNotSpecified;
	
	public PreferencesType getPreferences() throws ElementNotSpecified;
	
	public double getValue(Parameter parameter) throws ElementNotSpecified, ValueNotSpecified;
	
	public double getMinValue(Parameter parameter) throws ElementNotSpecified, ValueNotSpecified;
	
	public double getMaxValue(Parameter parameter) throws ElementNotSpecified, ValueNotSpecified;
	
	public double[] getRangeValue(Parameter parameter) throws ElementNotSpecified, ValueNotSpecified;
	
	public String getStringValue(Parameter parameter) throws ElementNotSpecified, ValueNotSpecified;
	
}
