package org.qcg.broker.schemas.jobdesc.wrapper;

import org.qcg.broker.schemas.exception.NoSuchParamException;
import org.qcg.broker.schemas.jobdesc.Task;

/**
 * 
 * @author Marcin Krystek
 *
 */
public interface TaskRequirements {

	public void wrap(Task task);
	
	
	public String[] getOsname() throws NoSuchParamException;
	
	public String[] getOstype() throws NoSuchParamException;
	
	public String[] getCpuarch() throws NoSuchParamException;
	
	public String[] getOsversion() throws NoSuchParamException;
	
	public String[] getOsrelease() throws NoSuchParamException;
	
	public String[] getApplication() throws NoSuchParamException;
	
	public String[] getHostname() throws NoSuchParamException;

	public String[] getRemoteSubmissionInterface() throws NoSuchParamException;

	public String[] getLocalResourceManager() throws NoSuchParamException;
	
	
	public double[] getMemory() throws NoSuchParamException;

	public double[] getMinMemory() throws NoSuchParamException;
	
	public double[] getMaxMemory() throws NoSuchParamException;
	
	public double[][] getRangeMemory() throws NoSuchParamException;
	
	
	public double[] getFreememory() throws NoSuchParamException;
	
	public double[] getMinFreememory() throws NoSuchParamException;
	
	public double[] getMaxFreememory() throws NoSuchParamException;
	
	public double[][] getRangFreememory() throws NoSuchParamException;
	
	
	public double[] getCpucount() throws NoSuchParamException;
	
	public double[] getMinCpucount() throws NoSuchParamException;
	
	public double[] getMaxCpucount() throws NoSuchParamException;

	public double[][] getRangeCpucount() throws NoSuchParamException;
	
	
	public double[] getFreecpus() throws NoSuchParamException;
	
	public double[] getMinFreecpus() throws NoSuchParamException;
	
	public double[] getMaxFreecpus() throws NoSuchParamException;
	
	public double[][] getRangeFreecpus() throws NoSuchParamException;
	
	
	public double[] getCpuspeed() throws NoSuchParamException;
	
	public double[] getMinCpuspeed() throws NoSuchParamException;
	
	public double[] getMaxCpuspeed() throws NoSuchParamException;
	
	public double[][] getRangeCpuspeed() throws NoSuchParamException;
	
	
	public double[] getDiskspace() throws NoSuchParamException;
	
	public double[] getMinDiskspace() throws NoSuchParamException;
	
	public double[] getMaxDiskspace() throws NoSuchParamException;
	
	public double[][] getRangeDiskspace() throws NoSuchParamException;
	
	
	public double[] getFreediskspace() throws NoSuchParamException;

	public double[] getMinFreediskspace() throws NoSuchParamException;
	
	public double[] getMaxFreediskspace() throws NoSuchParamException;
	
	public double[][] getRangeFreediskspace() throws NoSuchParamException;
	
	
	public double[] getBandwidth() throws NoSuchParamException;
	
	public double[] getMinBandwidth() throws NoSuchParamException;
	
	public double[] getMaxBandwidth() throws NoSuchParamException;
	
	public double[][] getRangeBandwidth() throws NoSuchParamException;
	
	
	public double[] getLatency() throws NoSuchParamException;
	
	public double[] getMinLatency() throws NoSuchParamException;
	
	public double[] getMaxLatency() throws NoSuchParamException;
	
	public double[][] getRangeLatency() throws NoSuchParamException;
	
	
	public double[] getCapacity() throws NoSuchParamException;
	
	public double[] getMinCapacity() throws NoSuchParamException;
	
	public double[] getMaxCapacity() throws NoSuchParamException;
	
	public double[][] getRangeCapacity() throws NoSuchParamException;
}
